Index: squid/src/auth/basic/helpers/MSNT/msntauth.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/msntauth.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/msntauth.c	Tue Sep  3 10:42:12 2002
@@ -0,0 +1,112 @@
+
+/*
+ * MSNT - Microsoft Windows NT domain squid authenticator module
+ * Version 2.0 by Stellar-X Pty Ltd, Antonino Iannella
+ * Sun Sep  2 14:39:53 CST 2001
+ * 
+ * Modified to act as a Squid authenticator module.
+ * Removed all Pike stuff.
+ * Returns OK for a successful authentication, or ERR upon error.
+ * 
+ * Uses code from -
+ * Andrew Tridgell 1997
+ * Richard Sharpe 1996
+ * Bill Welliver 1999
+ * Duane Wessels 2000 (wessels@squid-cache.org)
+ * 
+ * Released under GNU Public License
+ * 
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include <stdio.h>
+#include <signal.h>
+#include <syslog.h>
+#include <sys/time.h>
+
+#include "msntauth.h"
+
+extern char version[];
+char msntauth_version[] = "Msntauth v2.0.3 (C) 2 Sep 2001 Stellar-X Antonino Iannella.";
+
+/* Main program for simple authentication.
+ * Reads the denied user file. Sets alarm timer.
+ * Scans and checks for Squid input, and attempts to validate the user.
+ */
+
+int
+main()
+{
+    char username[256];
+    char password[256];
+    char wstr[256];
+
+    /* Read configuration file. Abort wildly if error. */
+    if (OpenConfigFile() == 1)
+	return 1;
+
+    /* Read denied and allowed user files.
+     * If they fails, there is a serious problem.
+     * Check syslog messages. Deny all users while in this state.
+     * The msntauth process should then be killed. */
+
+    if ((Read_denyusers() == 1) || (Read_allowusers() == 1)) {
+	while (1) {
+	    fgets(wstr, 255, stdin);
+	    puts("ERR");
+	    fflush(stdout);
+	}
+    }
+    /* Make Check_forchange() the handle for HUP signals.
+     * Don't use alarms any more. I don't think it was very
+     * portable between systems. */
+    signal(SIGHUP, Check_forchange);
+
+    while (1) {
+	/* Read whole line from standard input. Terminate on break. */
+	if (fgets(wstr, 255, stdin) == NULL)
+	    break;
+
+	/* Clear any current settings. Read new ones. Use \n as a 
+	 * convenient EOL marker which is not even there. */
+	username[0] = '\0';
+	password[0] = '\0';
+	sscanf(wstr, "%s %[^\n]", username, password);	/* Extract parameters */
+
+	/* Check for invalid or blank entries */
+	if ((username[0] == '\0') || (password[0] == '\0')) {
+	    puts("ERR");
+	    fflush(stdout);
+	    continue;
+	}
+	Checktimer();		/* Check if the user lists have changed */
+
+	/* Check if user is explicitly denied or allowed.
+	 * If user passes both checks, they can be authenticated. */
+
+	if (Check_user(username) == 1)
+	    puts("ERR");
+	else {
+	    if (QueryServers(username, password) == 0)
+		puts("OK");
+	    else
+		puts("ERR");
+	}
+
+	fflush(stdout);
+    }
+
+    return 0;
+}
Index: squid/src/auth/basic/helpers/MSNT/msntauth.conf
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/msntauth.conf:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/msntauth.conf	Tue Sep  3 10:42:12 2002
@@ -0,0 +1,13 @@
+
+# Sample MSNT authenticator configuration file
+# Antonino Iannella, Stellar-X Pty Ltd
+# Sun Sep  2 15:52:31 CST 2001
+
+# NT hosts to use. Best to put their IP addresses in /etc/hosts.
+server my_PDC		my_BDC		my_NTdomain
+server other_PDC	other_BDC	otherdomain
+
+# Denied and allowed users. Comment these if not needed.
+denyusers	/usr/local/squid/etc/denyusers
+allowusers	/usr/local/squid/etc/allowusers
+
Index: squid/src/auth/basic/helpers/MSNT/msntauth.h
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/msntauth.h:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/msntauth.h	Tue Sep  3 10:42:12 2002
@@ -0,0 +1,8 @@
+extern int OpenConfigFile(void);
+extern int QueryServers(char *, char *);
+extern void Checktimer(void);
+extern void Check_forchange();
+extern int Read_denyusers(void);
+extern int Read_allowusers(void);
+extern int Check_user(char *);
+extern int QueryServers(char *, char *);
Index: squid/src/auth/basic/helpers/MSNT/rfcnb-io.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/rfcnb-io.c:1.3.2.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/rfcnb-io.c	Tue Sep  3 10:42:13 2002
@@ -0,0 +1,419 @@
+/* UNIX RFCNB (RFC1001/RFC1002) NEtBIOS implementation
+ * 
+ * Version 1.0
+ * RFCNB IO Routines ...
+ * 
+ * Copyright (C) Richard Sharpe 1996
+ * 
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+/* #include <features.h> */
+#include "std-includes.h"
+#include "rfcnb-priv.h"
+#include "rfcnb-util.h"
+#include "rfcnb-io.h"
+#include <sys/uio.h>
+#include <sys/signal.h>
+#include <string.h>
+
+
+int RFCNB_Timeout = 0;		/* Timeout in seconds ... */
+
+void
+rfcnb_alarm(int sig)
+{
+
+    fprintf(stderr, "IO Timed out ...\n");
+
+}
+
+/* Set timeout value and setup signal handling */
+
+int
+RFCNB_Set_Timeout(int seconds)
+{
+#ifdef __GLIBC__
+    int temp;
+#endif
+    /* If we are on a Bezerkeley system, use sigvec, else sigaction */
+#ifndef SA_RESTART
+    struct sigvec invec, outvec;
+#else
+    struct sigaction inact, outact;
+#endif
+
+    RFCNB_Timeout = seconds;
+
+    if (RFCNB_Timeout > 0) {	/* Set up handler to ignore but not restart */
+
+#ifndef SA_RESTART
+	invec.sv_handler = (void (*)()) rfcnb_alarm;
+	invec.sv_mask = 0;
+	invec.sv_flags = SV_INTERRUPT;
+
+	if (sigvec(SIGALRM, &invec, &outvec) < 0)
+	    return (-1);
+#else
+	inact.sa_handler = (void (*)()) rfcnb_alarm;
+#ifdef SOLARIS
+	/* Solaris seems to have an array of vectors ... */
+	inact.sa_mask.__sigbits[0] = 0;
+	inact.sa_mask.__sigbits[1] = 0;
+	inact.sa_mask.__sigbits[2] = 0;
+	inact.sa_mask.__sigbits[3] = 0;
+#else
+#ifdef __GLIBC__
+	for (temp = 0; temp < 32; temp++)
+	    inact.sa_mask.__val[temp] = 0;
+#else
+	/* AI - If you have problems with this line, contact the author */
+	/* AI - This is the old line: inact.sa_mask = 0; */
+	memset(&inact.sa_mask, 0, sizeof(inact.sa_mask));
+#endif
+#endif
+	inact.sa_flags = 0;	/* Don't restart */
+
+	if (sigaction(SIGALRM, &inact, &outact) < 0)
+	    return (-1);
+
+#endif
+
+    }
+    return (0);
+
+}
+
+/* Discard the rest of an incoming packet as we do not have space for it
+ * in the buffer we allocated or were passed ...                         */
+
+int
+RFCNB_Discard_Rest(struct RFCNB_Con *con, int len)
+{
+    char temp[100];		/* Read into here */
+    int rest, this_read, bytes_read;
+
+    /* len is the amount we should read */
+
+#ifdef RFCNB_DEBUG
+    fprintf(stderr, "Discard_Rest called to discard: %i\n", len);
+#endif
+
+    rest = len;
+
+    while (rest > 0) {
+
+	this_read = (rest > sizeof(temp) ? sizeof(temp) : rest);
+
+	bytes_read = read(con->fd, temp, this_read);
+
+	if (bytes_read <= 0) {	/* Error so return */
+
+	    if (bytes_read < 0)
+		RFCNB_errno = RFCNBE_BadRead;
+	    else
+		RFCNB_errno = RFCNBE_ConGone;
+
+	    RFCNB_saved_errno = errno;
+	    return (RFCNBE_Bad);
+
+	}
+	rest = rest - bytes_read;
+
+    }
+
+    return (0);
+
+}
+
+
+/* Send an RFCNB packet to the connection.
+ * 
+ * We just send each of the blocks linked together ... 
+ * 
+ * If we can, try to send it as one iovec ... 
+ * 
+ */
+
+int
+RFCNB_Put_Pkt(struct RFCNB_Con *con, struct RFCNB_Pkt *pkt, int len)
+{
+    int len_sent, tot_sent, this_len;
+    struct RFCNB_Pkt *pkt_ptr;
+    char *this_data;
+    int i;
+    struct iovec io_list[10];	/* We should never have more      */
+    /* If we do, this will blow up ... */
+
+    /* Try to send the data ... We only send as many bytes as len claims */
+    /* We should try to stuff it into an IOVEC and send as one write     */
+
+
+    pkt_ptr = pkt;
+    len_sent = tot_sent = 0;	/* Nothing sent so far */
+    i = 0;
+
+    while ((pkt_ptr != NULL) & (i < 10)) {	/* Watch that magic number! */
+
+	this_len = pkt_ptr->len;
+	this_data = pkt_ptr->data;
+	if ((tot_sent + this_len) > len)
+	    this_len = len - tot_sent;	/* Adjust so we don't send too much */
+
+	/* Now plug into the iovec ... */
+
+	io_list[i].iov_len = this_len;
+	io_list[i].iov_base = this_data;
+	i++;
+
+	tot_sent += this_len;
+
+	if (tot_sent == len)
+	    break;		/* Let's not send too much */
+
+	pkt_ptr = pkt_ptr->next;
+
+    }
+
+#ifdef RFCNB_DEBUG
+    fprintf(stderr, "Frags = %i, tot_sent = %i\n", i, tot_sent);
+#endif
+
+    /* Set up an alarm if timeouts are set ... */
+
+    if (RFCNB_Timeout > 0)
+	alarm(RFCNB_Timeout);
+
+    if ((len_sent = writev(con->fd, io_list, i)) < 0) {		/* An error */
+
+	con->rfc_errno = errno;
+	if (errno == EINTR)	/* We were interrupted ... */
+	    RFCNB_errno = RFCNBE_Timeout;
+	else
+	    RFCNB_errno = RFCNBE_BadWrite;
+	RFCNB_saved_errno = errno;
+	return (RFCNBE_Bad);
+
+    }
+    if (len_sent < tot_sent) {	/* Less than we wanted */
+	if (errno == EINTR)	/* We were interrupted */
+	    RFCNB_errno = RFCNBE_Timeout;
+	else
+	    RFCNB_errno = RFCNBE_BadWrite;
+	RFCNB_saved_errno = errno;
+	return (RFCNBE_Bad);
+    }
+    if (RFCNB_Timeout > 0)
+	alarm(0);		/* Reset that sucker */
+
+#ifdef RFCNB_DEBUG
+
+    fprintf(stderr, "Len sent = %i ...\n", len_sent);
+    RFCNB_Print_Pkt(stderr, "sent", pkt, len_sent);	/* Print what send ... */
+
+#endif
+
+    return (len_sent);
+
+}
+
+/* Read an RFCNB packet off the connection. 
+ * 
+ * We read the first 4 bytes, that tells us the length, then read the
+ * rest. We should implement a timeout, but we don't just yet 
+ * 
+ */
+
+
+int
+RFCNB_Get_Pkt(struct RFCNB_Con *con, struct RFCNB_Pkt *pkt, int len)
+{
+    int read_len, pkt_len;
+    char hdr[RFCNB_Pkt_Hdr_Len];	/* Local space for the header */
+    struct RFCNB_Pkt *pkt_frag;
+    int more, this_time, offset, frag_len, this_len;
+    BOOL seen_keep_alive = TRUE;
+
+    /* Read that header straight into the buffer */
+
+    if (len < RFCNB_Pkt_Hdr_Len) {	/* What a bozo */
+
+#ifdef RFCNB_DEBUG
+	fprintf(stderr, "Trying to read less than a packet:");
+	perror("");
+#endif
+	RFCNB_errno = RFCNBE_BadParam;
+	return (RFCNBE_Bad);
+
+    }
+    /* We discard keep alives here ... */
+
+    if (RFCNB_Timeout > 0)
+	alarm(RFCNB_Timeout);
+
+    while (seen_keep_alive) {
+
+	if ((read_len = read(con->fd, hdr, sizeof(hdr))) < 0) {		/* Problems */
+#ifdef RFCNB_DEBUG
+	    fprintf(stderr, "Reading the packet, we got:");
+	    perror("");
+#endif
+	    if (errno == EINTR)
+		RFCNB_errno = RFCNBE_Timeout;
+	    else
+		RFCNB_errno = RFCNBE_BadRead;
+	    RFCNB_saved_errno = errno;
+	    return (RFCNBE_Bad);
+
+	}
+	/* Now we check out what we got */
+
+	if (read_len == 0) {	/* Connection closed, send back eof?  */
+
+#ifdef RFCNB_DEBUG
+	    fprintf(stderr, "Connection closed reading\n");
+#endif
+
+	    if (errno == EINTR)
+		RFCNB_errno = RFCNBE_Timeout;
+	    else
+		RFCNB_errno = RFCNBE_ConGone;
+	    RFCNB_saved_errno = errno;
+	    return (RFCNBE_Bad);
+
+	}
+	if (RFCNB_Pkt_Type(hdr) == RFCNB_SESSION_KEEP_ALIVE) {
+
+#ifdef RFCNB_DEBUG
+	    fprintf(stderr, "RFCNB KEEP ALIVE received\n");
+#endif
+
+	} else {
+	    seen_keep_alive = FALSE;
+	}
+
+    }
+
+    /* What if we got less than or equal to a hdr size in bytes? */
+
+    if (read_len < sizeof(hdr)) {	/* We got a small packet */
+
+	/* Now we need to copy the hdr portion we got into the supplied packet */
+
+	memcpy(pkt->data, hdr, read_len);	/*Copy data */
+
+#ifdef RFCNB_DEBUG
+	RFCNB_Print_Pkt(stderr, "rcvd", pkt, read_len);
+#endif
+
+	return (read_len);
+
+    }
+    /* Now, if we got at least a hdr size, alloc space for rest, if we need it */
+
+    pkt_len = RFCNB_Pkt_Len(hdr);
+
+#ifdef RFCNB_DEBUG
+    fprintf(stderr, "Reading Pkt: Length = %i\n", pkt_len);
+#endif
+
+    /* Now copy in the hdr */
+
+    memcpy(pkt->data, hdr, sizeof(hdr));
+
+    /* Get the rest of the packet ... first figure out how big our buf is? */
+    /* And make sure that we handle the fragments properly ... Sure should */
+    /* use an iovec ...                                                    */
+
+    if (len < pkt_len)		/* Only get as much as we have space for */
+	more = len - RFCNB_Pkt_Hdr_Len;
+    else
+	more = pkt_len;
+
+    this_time = 0;
+
+    /* We read for each fragment ... */
+
+    if (pkt->len == read_len) {	/* If this frag was exact size */
+	pkt_frag = pkt->next;	/* Stick next lot in next frag */
+	offset = 0;		/* then we start at 0 in next  */
+    } else {
+	pkt_frag = pkt;		/* Otherwise use rest of this frag */
+	offset = RFCNB_Pkt_Hdr_Len;	/* Otherwise skip the header       */
+    }
+
+    frag_len = pkt_frag->len;
+
+    if (more <= frag_len)	/* If len left to get less than frag space */
+	this_len = more;	/* Get the rest ...                        */
+    else
+	this_len = frag_len - offset;
+
+    while (more > 0) {
+
+	if ((this_time = read(con->fd, (pkt_frag->data) + offset, this_len)) <= 0) {	/* Problems */
+
+	    if (errno == EINTR) {
+
+		RFCNB_errno = RFCNB_Timeout;
+
+	    } else {
+		if (this_time < 0)
+		    RFCNB_errno = RFCNBE_BadRead;
+		else
+		    RFCNB_errno = RFCNBE_ConGone;
+	    }
+
+	    RFCNB_saved_errno = errno;
+	    return (RFCNBE_Bad);
+
+	}
+#ifdef RFCNB_DEBUG
+	fprintf(stderr, "Frag_Len = %i, this_time = %i, this_len = %i, more = %i\n", frag_len,
+	    this_time, this_len, more);
+#endif
+
+	read_len = read_len + this_time;	/* How much have we read ... */
+
+	/* Now set up the next part */
+
+	if (pkt_frag->next == NULL)
+	    break;		/* That's it here */
+
+	pkt_frag = pkt_frag->next;
+	this_len = pkt_frag->len;
+	offset = 0;
+
+	more = more - this_time;
+
+    }
+
+#ifdef RFCNB_DEBUG
+    fprintf(stderr, "Pkt Len = %i, read_len = %i\n", pkt_len, read_len);
+    RFCNB_Print_Pkt(stderr, "rcvd", pkt, read_len + sizeof(hdr));
+#endif
+
+    if (read_len < (pkt_len + sizeof(hdr))) {	/* Discard the rest */
+
+	return (RFCNB_Discard_Rest(con, (pkt_len + sizeof(hdr)) - read_len));
+
+    }
+    if (RFCNB_Timeout > 0)
+	alarm(0);		/* Reset that sucker */
+
+    return (read_len + sizeof(RFCNB_Hdr));
+}
Index: squid/src/auth/basic/helpers/MSNT/smbencrypt.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/smbencrypt.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/smbencrypt.c	Tue Sep  3 10:42:14 2002
@@ -0,0 +1,209 @@
+/* 
+ * Unix SMB/Netbios implementation.
+ * Version 1.9.
+ * SMB parameters and setup
+ * Copyright (C) Andrew Tridgell 1992-1997
+ * Modified by Jeremy Allison 1995.
+ * 
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include <string.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <dirent.h>
+#include <string.h>
+#include <ctype.h>
+
+/* AI inclusion for Solaris filesystem */
+#ifdef SOLARIS
+#include <sys/vfs.h>
+#endif
+
+#include "smblib-priv.h"
+#define uchar unsigned char
+extern int DEBUGLEVEL;
+
+#include "byteorder.h"
+
+char *StrnCpy(char *dest, char *src, int n);
+void strupper(char *s);
+extern void E_P16(unsigned char *, unsigned char *);
+extern void E_P24(unsigned char *, unsigned char *, unsigned char *);
+extern void mdfour(unsigned char *, unsigned char *, int);
+
+
+/*
+ * This implements the X/Open SMB password encryption
+ * It takes a password, a 8 byte "crypt key" and puts 24 bytes of 
+ * encrypted password into p24 */
+void
+SMBencrypt(uchar * passwd, uchar * c8, uchar * p24)
+{
+    uchar p14[15], p21[21];
+
+    memset(p21, '\0', 21);
+    memset(p14, '\0', 14);
+    StrnCpy((char *) p14, (char *) passwd, 14);
+
+    strupper((char *) p14);
+    E_P16(p14, p21);
+    E_P24(p21, c8, p24);
+}
+
+/* Routines for Windows NT MD4 Hash functions. */
+static int
+_my_wcslen(int16 * str)
+{
+    int len = 0;
+    while (*str++ != 0)
+	len++;
+    return len;
+}
+
+/*
+ * Convert a string into an NT UNICODE string.
+ * Note that regardless of processor type 
+ * this must be in intel (little-endian)
+ * format.
+ */
+
+static int
+_my_mbstowcs(int16 * dst, uchar * src, int len)
+{
+    int i;
+    int16 val;
+
+    for (i = 0; i < len; i++) {
+	val = *src;
+	SSVAL(dst, 0, val);
+	dst++;
+	src++;
+	if (val == 0)
+	    break;
+    }
+    return i;
+}
+
+/* 
+ * Creates the MD4 Hash of the users password in NT UNICODE.
+ */
+
+void
+E_md4hash(uchar * passwd, uchar * p16)
+{
+    int len;
+    int16 wpwd[129];
+
+    /* Password cannot be longer than 128 characters */
+    len = strlen((char *) passwd);
+    if (len > 128)
+	len = 128;
+    /* Password must be converted to NT unicode */
+    _my_mbstowcs(wpwd, passwd, len);
+    wpwd[len] = 0;		/* Ensure string is null terminated */
+    /* Calculate length in bytes */
+    len = _my_wcslen(wpwd) * sizeof(int16);
+
+    mdfour(p16, (unsigned char *) wpwd, len);
+}
+
+/* Does the NT MD4 hash then des encryption. */
+
+void
+SMBNTencrypt(uchar * passwd, uchar * c8, uchar * p24)
+{
+    uchar p21[21];
+
+    memset(p21, '\0', 21);
+
+    E_md4hash(passwd, p21);
+    E_P24(p21, c8, p24);
+}
+
+/* Does both the NT and LM owfs of a user's password */
+
+void
+nt_lm_owf_gen(char *pwd, char *nt_p16, char *p16)
+{
+    char passwd[130];
+    StrnCpy(passwd, pwd, sizeof(passwd) - 1);
+
+    /* Calculate the MD4 hash (NT compatible) of the password */
+    memset(nt_p16, '\0', 16);
+    E_md4hash((uchar *) passwd, (uchar *) nt_p16);
+
+    /* Mangle the passwords into Lanman format */
+    passwd[14] = '\0';
+    strupper(passwd);
+
+    /* Calculate the SMB (lanman) hash functions of the password */
+
+    memset(p16, '\0', 16);
+    E_P16((uchar *) passwd, (uchar *) p16);
+
+    /* clear out local copy of user's password (just being paranoid). */
+    bzero(passwd, sizeof(passwd));
+}
+
+/****************************************************************************
+line strncpy but always null terminates. Make sure there is room!
+****************************************************************************/
+char *
+StrnCpy(char *dest, char *src, int n)
+{
+    char *d = dest;
+    if (!dest)
+	return (NULL);
+    if (!src) {
+	*dest = 0;
+	return (dest);
+    }
+    while (n-- && (*d++ = *src++));
+    *d = 0;
+    return (dest);
+}
+
+void
+strupper(char *s)
+{
+    while (*s) {
+#if UNUSED_CODE
+#if !defined(KANJI_WIN95_COMPATIBILITY)
+	if (lp_client_code_page() == KANJI_CODEPAGE) {
+
+	    if (is_shift_jis(*s)) {
+		if (is_sj_lower(s[0], s[1]))
+		    s[1] = sj_toupper2(s[1]);
+		s += 2;
+	    } else if (is_kana(*s)) {
+		s++;
+	    } else {
+		if (islower(*s))
+		    *s = toupper(*s);
+		s++;
+	    }
+	} else
+#endif /* KANJI_WIN95_COMPATIBILITY */
+#endif /* UNUSED_CODE */
+	{
+	    if (islower(*s))
+		*s = toupper(*s);
+	    s++;
+	}
+    }
+}
